#ifndef CHIP_STM32H7XX_REGS_USART_H_
#define CHIP_STM32H7XX_REGS_USART_H_

#include <stdint.h>
#include "chip_devtype_spec_features.h"

#define CHIP_SUPPORT_USART_PRESC        1
#define CHIP_SUPPORT_USART_FIFO         1
#define CHIP_SUPPORT_USART_SYNC_SLAVE   1
#define CHIP_SUPPORT_USART_TCBGT_FLAG   1

#include "stm32_usart_v2_regs.h"

#if CHIP_DEV_SUPPORT_USART9_10
    #define CHIP_DEV_UART_CNT  10
#else
    #define CHIP_DEV_UART_CNT  8
#endif
#define CHIP_DEV_LPUART_CNT     1





#define CHIP_REGS_USART1                ((CHIP_REGS_USART_T *) CHIP_MEMRGN_ADDR_PERIPH_USART1)
#define CHIP_REGS_USART2                ((CHIP_REGS_USART_T *) CHIP_MEMRGN_ADDR_PERIPH_USART2)
#define CHIP_REGS_USART3                ((CHIP_REGS_USART_T *) CHIP_MEMRGN_ADDR_PERIPH_USART3)
#define CHIP_REGS_UART4                 ((CHIP_REGS_USART_T *) CHIP_MEMRGN_ADDR_PERIPH_UART4)
#define CHIP_REGS_UART5                 ((CHIP_REGS_USART_T *) CHIP_MEMRGN_ADDR_PERIPH_UART5)
#define CHIP_REGS_USART6                ((CHIP_REGS_USART_T *) CHIP_MEMRGN_ADDR_PERIPH_USART6)
#define CHIP_REGS_UART7                 ((CHIP_REGS_USART_T *) CHIP_MEMRGN_ADDR_PERIPH_UART7)
#define CHIP_REGS_UART8                 ((CHIP_REGS_USART_T *) CHIP_MEMRGN_ADDR_PERIPH_UART8)
#if CHIP_DEV_SUPPORT_USART9_10
#define CHIP_REGS_UART9                 ((CHIP_REGS_USART_T *) CHIP_MEMRGN_ADDR_PERIPH_UART9)
#define CHIP_REGS_USART10               ((CHIP_REGS_USART_T *) CHIP_MEMRGN_ADDR_PERIPH_USART10)
#endif
#define CHIP_REGS_LPUART1               ((CHIP_REGS_USART_T *) CHIP_MEMRGN_ADDR_PERIPH_LPUART1)


#define CHIP_USART_SUPPORT_SYNC(n)      (((n) == 1) || ((n) == 2) || ((n) == 3) || ((n) == 6))
#define CHIP_USART_SUPPORT_FIFO(n)      1
#define CHIP_USART_SUPPORT_PRESC(n)     1

#define CHIP_LPUART_SUPPORT_FIFO(n)     1
#define CHIP_LPUART_SUPPORT_FIFO(n)     1


#endif // CHIP_STM32H7XX_REGS_USART_H_
